package com.idiot.operationbackend.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.idiot.operationbackend.entity.FansActionStat;
import com.idiot.operationbackend.mappers.FansActionStatMapper;
import com.idiot.operationbackend.service.facade.FansActionStatService;
import com.idiot.operationbackend.support.Constants;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.LocalTime;
import java.util.List;

/**
 * @author wang xiao
 * @date Created in 11:33 2020/9/16
 */
@Service
public class FansActionStatServiceImpl extends ServiceImpl<FansActionStatMapper, FansActionStat>
        implements FansActionStatService {

    @Override
    public int countInactiveFansNum(String accountId, long startDate, long endDate) {
        return count(Wrappers.<FansActionStat>lambdaQuery().eq(FansActionStat::getAccountId,accountId)
                .ne(FansActionStat::getAction,"3")
                .ge(FansActionStat::getCreateTime,startDate)
                .le(FansActionStat::getCreateTime,endDate));
    }


    @Override
    public List<FansActionStat> queryFansActionStat(String accountId, String startDate, String endDate) {
        LocalDate var1 =LocalDate.parse(startDate, Constants.DATE_FORMATTER);
        LocalDate var2 =LocalDate.parse(endDate, Constants.DATE_FORMATTER);
        long start =  var1.atTime(LocalTime.of(0,0,0)).toInstant(Constants.DEFAULT_ZONE).getEpochSecond();
        long end = var2.atTime(LocalTime.of(23,59,59)).toInstant(Constants.DEFAULT_ZONE).getEpochSecond();
        return list(Wrappers.<FansActionStat>lambdaQuery().eq(FansActionStat::getAccountId,accountId)
                .ge(FansActionStat::getCreateTime,start)
                .le(FansActionStat::getCreateTime,end)
                .orderByAsc(FansActionStat::getCreateTime));
    }


    @Override
    public List<FansActionStat> queryFansActionStat(String accountId, long start, long end) {
          return list(Wrappers.<FansActionStat>lambdaQuery().eq(FansActionStat::getAccountId,accountId)
                .ge(FansActionStat::getCreateTime,start)
                .le(FansActionStat::getCreateTime,end)
                .orderByAsc(FansActionStat::getCreateTime));
    }
}
